precision highp int;
precision highp float;
 #include <OgreUnifiedShader.h>
varying vec2 vUv;
    uniform sampler2D tex;
uniform float opacity;
uniform float opacityMultiplier;
uniform float fontSizeCur;
uniform vec3 color;
uniform float threshold;
uniform float softness;
const float G_fontSizePixels = 64.0;
const float G_distFieldWidth = 32.0;
const float G_distanceOffset = 0.0;
varying vec4 vHazeColor;
void main()
{
    float _sample = texture2D(tex, vUv).r;
    float distValue = G_distFieldWidth * (_sample - 0.5);
    float q = G_fontSizePixels / fontSizeCur;
    float alpha = smoothstep(q * (-threshold - softness * 0.5), q * (-threshold + softness * 0.5),
                             distValue + G_distanceOffset);
    vec3 c = color;
    c.rgb = mix(c.rgb, vHazeColor.rgb, vHazeColor.a);
    gl_FragColor = vec4(c, alpha * opacity * opacityMultiplier);
}
